/*
 * huffman_coder - Encode/Decode files using Huffman encoding.
 * Copyright (C) 2003  Douglas Ryan Richardson; Gauss Interprise, Inc
 *                     Modified by Markus Nix; Docuverse.de
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef HUFFMAN_HUFFALGO_H
#define HUFFMAN_HUFFALGO_H

#include <stdio.h>

int _huffman_encode_file(FILE *in, FILE *out);
int _huffman_decode_file(FILE *in, FILE *out);
int _huffman_encode(const unsigned char *bufin,
              unsigned int bufinlen,
              unsigned char **pbufout,
              unsigned int *pbufoutlen);
int _huffman_decode(const unsigned char *bufin,
              unsigned int bufinlen,
              unsigned char **bufout,
              unsigned int *pbufoutlen);

#endif
