/*
+----------------------------------------------------------------------+
| PHP Version 5                                                        |
+----------------------------------------------------------------------+
| Copyright (c) 1997-2004 The PHP Group                                |
+----------------------------------------------------------------------+
| This source file is subject to version 3.0 of the PHP license,       |
| that is bundled with this package in the file LICENSE, and is        |
| available through the world-wide-web at the following url:           |
| http://www.php.net/license/3_0.txt.                                  |
| If you did not receive a copy of the PHP license and are unable to   |
| obtain it through the world-wide-web, please send a note to          |
| license@php.net so we can mail you a copy immediately.               |
+----------------------------------------------------------------------+
| Author: Markus Nix <mnix@docuverse.de>                               |
+----------------------------------------------------------------------+
*/

/* $Id: php_huffman.h,v 1.2 2004/08/26 11:10:36 docuverse_de Exp $ */

#ifndef PHP_HUFFMAN_H
#define PHP_HUFFMAN_H

#define HUFFMAN_VERSION "0.2"

#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif

extern zend_module_entry huffman_module_entry;
#define phpext_huffman_ptr &huffman_module_entry

#ifdef PHP_WIN32
#define PHP_HUFFMAN_API __declspec(dllexport)
#else
#define PHP_HUFFMAN_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(huffman);
PHP_MSHUTDOWN_FUNCTION(huffman);
PHP_RINIT_FUNCTION(huffman);
PHP_RSHUTDOWN_FUNCTION(huffman);
PHP_MINFO_FUNCTION(huffman);

PHP_FUNCTION(huffman_encode);
PHP_FUNCTION(huffman_decode);
PHP_FUNCTION(huffman_encode_file);
PHP_FUNCTION(huffman_decode_file);

#ifdef ZTS
#define HUFFMAN_G(v) TSRMG(huffman_globals_id, zend_huffman_globals *, v)
#else
#define HUFFMAN_G(v) (huffman_globals.v)
#endif

#endif /* PHP_HUFFMAN_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
